'use strict';

exports.__esModule = true;
exports['default'] = applyMiddleware;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _rx = require('rx');

var _rx2 = _interopRequireDefault(_rx);

var _compose = require('./compose');

var _compose2 = _interopRequireDefault(_compose);

function createNewDispatch(middleware, store) {
  var dispatchFunctions = middleware.map(function (m) {
    return m(store);
  });
  dispatchFunctions.push(store.dispatch);

  return _compose2['default'].apply(undefined, dispatchFunctions);
}

function createNewDispatcher(middleware, store) {
  var newDispatch = createNewDispatch(middleware, store);
  var newDispatcher$ = new _rx2['default'].Subject();
  newDispatcher$.subscribe(newDispatch);

  return newDispatcher$;
}

function applyMiddleware() {
  for (var _len = arguments.length, middleware = Array(_len), _key = 0; _key < _len; _key++) {
    middleware[_key] = arguments[_key];
  }

  return function (createStore) {
    return function (reducer, initState) {
      var store = createStore(reducer, initState);
      var newDispatcher$ = createNewDispatcher(middleware, store);

      store.dispatcher$ = newDispatcher$;
      store.dispatch = function (action) {
        newDispatcher$.onNext(action);
        return action;
      };

      return store;
    };
  };
}

module.exports = exports['default'];