'use strict';

exports.__esModule = true;
exports['default'] = bindActionCreators;

function bindActionCreators(actionCreators, dispatch) {
  return Object.keys(actionCreators).reduce(function (result, key) {
    var actionCreator = actionCreators[key];
    if (typeof actionCreator === 'function') {
      result[key] = function () {
        return dispatch(actionCreator.apply(undefined, arguments));
      };
    }

    return result;
  }, {});
}

module.exports = exports['default'];